
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C++primer书店程序 / 憋错料</title>

    <meta name="description" content="C++primer书店程序 #include &lt;iostream&gt; #include &lt;string&gt; #include &lt;cassert&gt; #include &lt;algorithm&gt; #include &lt;vector&gt; using namespace std; class Sales_data { friend std::istream&amp; operator&gt;&gt;(std::istream&amp;, Sales_data&amp;); frien ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C++primer书店程序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>#include &lt;iostream&gt;
#include &lt;string&gt;
#include &lt;cassert&gt;
#include &lt;algorithm&gt;
#include &lt;vector&gt;
using namespace std;

class Sales_data
{
    friend std::istream&amp; operator&gt;&gt;(std::istream&amp;, Sales_data&amp;);
    friend std::ostream&amp; operator&lt;&lt;(std::ostream&amp;, const Sales_data&amp;);
    friend Sales_data operator+(const Sales_data&amp;,const Sales_data&amp;);//非成员函数（对称性）
    friend bool operator==(const Sales_data&amp;,const Sales_data&amp;);
    friend bool operator!=(const Sales_data&amp;,const Sales_data&amp;);

public:
    Sales_data():units_sold(0),revenue(0.0){}
    Sales_data(const std::string &amp;s):bookNo(s),units_sold(0),revenue(0.0){}
    Sales_data(const std::string &amp;s,unsigned n,double p):bookNo(s),units_sold(n),revenue(n*p){}
    Sales_data(std::istream &amp;is);

    Sales_data&amp; operator+=(const Sales_data&amp;);//成员函数(复合赋值一般是成员函数)
    std::string isbn()const{return bookNo;}

    Sales_data&amp; operator=(const std::string &amp;s);
private:
    inline double avg_price()const;//inline
private:
    std::string bookNo; //isbn
    unsigned units_sold;//销售量
    double revenue;     //总价
};

inline double Sales_data::avg_price() const
{
    return units_sold ? revenue/units_sold : 0;
}

Sales_data::Sales_data(std::istream &amp;is)
{
    is&gt;&gt;*this;
}

std::istream&amp; operator&gt;&gt;(std::istream&amp; is,Sales_data&amp; item)
{
    double price=0.0;
    is&gt;&gt;item.bookNo&gt;&gt;item.units_sold&gt;&gt;price;
    if(is)//检测流的状态，输入易错且改写对象数据
        item.revenue=item.units_sold*price;
    else
        item=Sales_data();
    return is;
}

std::ostream&amp; operator&lt;&lt;(std::ostream&amp; os, const Sales_data&amp; item)
{
    os&lt;&lt;item.isbn()&lt;&lt;&quot; &quot;&lt;&lt;item.units_sold&lt;&lt;&quot; &quot;
      &lt;&lt;item.revenue&lt;&lt;&quot; &quot;&lt;&lt;item.avg_price();
    return os;
}

Sales_data operator+(const Sales_data&amp; item1,const Sales_data&amp; item2)
{
    Sales_data s(item1);
    s+=item2;//调用复合赋值
    return s;
}

Sales_data&amp; Sales_data::operator+=(const Sales_data&amp; rhs)
{
    units_sold+=rhs.units_sold;
    revenue+=rhs.revenue;
    return *this;
}

bool operator==(const Sales_data&amp; lhs,const Sales_data&amp; rhs)
{
    return lhs.bookNo==rhs.bookNo &amp;&amp;
        lhs.units_sold==rhs.units_sold &amp;&amp;
        lhs.revenue==rhs.revenue;
}

bool operator!=(const Sales_data&amp; lhs,const Sales_data&amp; rhs)
{
    return !(lhs==rhs);
}

Sales_data&amp; Sales_data::operator=(const std::string &amp;s)
{
    *this=Sales_data(s);
    return *this;
}</pre>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 14:50:39 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C++primer书店程序的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0alkxQM.html" rel="bookmark">解决《C&plus;&plus; Primer》第一章书店程序问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一章1.6节有一个书店程序问题,按照书上的代码,编译器就会报错,显示 aa.cpp:13:32: error: no match for call to '(std::__cxx11::string {aka std::__cxx11::basic_string&lt;char&gt;}) ()' if(item1.isbn()==item2.isbn()) ^ aa.cpp:13:46: error: no match for call to '(std::__cxx11::string {aka s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/026E9n0.html" rel="bookmark">《c&plus;&plus; primer》书店程序&mdash;&mdash;Chapter2</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Sales_data.h 1 #ifndef SALES_DATA_H 2 #define SALES_DATA_H 3 4 #include &quot;Version_test.h&quot; 5 6 #include &lt;string&gt; 7 8 struct Sales_data { 9 std::string bookNo; 10 #ifdef IN_CLASS_INITS 11 unsigned units_sold = 0; 12 double revenue = 0.0; 13 #			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eZK6D3.html" rel="bookmark">《c&plus;&plus; primer》书店程序&mdash;&mdash;Chapter7</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Sales_data.h 1 #ifndef SALES_DATA_H 2 #define SALES_DATA_H 3 4 #include &quot;Version_test.h&quot; 5 6 #include &lt;string&gt; 7 #include &lt;iostream&gt; 8 9 class Sales_data { 10 friend Sales_data add(const Sales_data&amp;, const Sales_data&amp;); 11 fr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02mlOpM.html" rel="bookmark">19天学完C&plus;&plus;Primer【1】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1:查阅你使用的编译器的文档,确定它所使用的文件命名约定.编译并运行第2页的main程序. 解答:跳过不影响学习. 1.2:改写程序,让它返回-1.返回值-1通常被当做程序错误的标示.重新编译并运行你的程序,观察你的系统如何处理main返回的错误标识. 解答:跳过不影响学习. 1.3:编写程序,在标准输出上打印Hello, World. 解答: include &lt;isotream&gt; using namespace std; int main() { cout&lt;&lt;”Hello,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3v5bYL0.html" rel="bookmark">c&plus;&plus; primer plus学习笔记&lpar;栈指针&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				c++ primer plus 程序清单14.5 程序清单14.6 模拟如下情况: 某人将一车文件交给plodson,如果plodson的收取蓝是空的,他将取出车中最上面的文件,将它放入收 取蓝,如果收取蓝是满的,他将取出栏中最上面的文件,并进行处理,然后放入发出蓝,如果收取蓝不空不满 plodson将采用抛硬币的方式来决定采取措施. 很明显,我们需要使用栈去管理上述文件. 1 #ifndef STACK_H_ 2 #define STACK_H_ 3 4 //定义类模板 5 template			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3529mR4.html" rel="bookmark">C&plus;&plus;中文件的读取操作，如何读取多行数据，如何一个一个的读取数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://blog.csdn.net/sunhero2010/article/details/50980591 练习8.1:编写函数.接受一个istream&amp;参数,返回值类型也是istream&amp;.此函数必须从给定流中读取数据,直至遇到文件结束标识时停止. [cpp] view plain copy #include &lt;iostream&gt; #include &lt;stdexcept&gt; using std::istream; using std::cin; using 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEQBeKM.html" rel="bookmark">第 13 章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				13.1 [出题思路] 理解拷贝构造函数的基本概念. [解答] 如果构造函数的第一个参数是自身类类型的引用,且所有其他参数(如果有的话)都有默认值,则此构造函数是拷贝构造函数.拷贝构造函数在以下几种情况下会被使用: 拷贝初始化(用 = 定义变量). 将一个对象作为实参传递给非引用类型的形参. 一个返回类型为非引用类型的函数返回一个对象. 用花括号列表初始化一个数组中的元素或一个聚合类中的成员. 初始化标准库容器或调用其 insert/push 操作时,容器会对其元素进行拷贝初始化. 13.2 [			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoGZqQM.html" rel="bookmark">【足迹C&plus;&plus;primer】41、文本查询程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/** * 功能:使用标准库:文本查询程序 * 时间:2014年7月10日09:10:15 * 作者:cutter_point */ #include&lt;iostream&gt; #include&lt;map&gt; #include&lt;set&gt; #include&lt;fstream&gt; #include&lt;sstream&gt; #include&lt;string&gt; #include&lt;vector&gt; #include&lt;memory&gt; using			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kD8jz3.html" rel="bookmark">《C&plus;&plus; Primer》P314中使用insert重写单词统计程序的扩展</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编写程序统计并输出所读入的单词出现的次数 想与习题10-1相结合,也就是先输入几组 map&lt;string, int&gt;类型,存入vector中. 再输入单词word,如果已经存在则在key对应的value+1 如果不存在,则插入并使得其value为1. 之前的问题是-&gt;输入了一次之后,再要输入单词word,读不进.(呵呵 果然小白) 看到11章之后,知道要用语句cin.clear;使得输入流重新有效. 再然后 重新熟悉了iterator对map的操作. #include &lt;iostr			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGeQoM.html" rel="bookmark" class="title">LintCode - Remove Duplicates from Sorted List</a>
					<div>
						LintCode - Remove Duplicates from Sorted List LintCode - Remove Duplicates from Sorted List Web Link ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5eODM.html" rel="bookmark" class="title">GBRT 要点理解</a>
					<div>
						1. 首先要理解Boost和Gradient Boost. 前者是在算法开始时候,,为每一个样本赋上一个相等的权重值,也就是说,最开始的时候,大家都是一样重要的.在每一次训练中得到的模型,会使得数据点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eq8850.html" rel="bookmark" class="title">&lbrack;CSS&rsqb; Use CSS Counters to Create Pure CSS Dynamic Lists</a>
					<div>
						CSS counters let you create dynamic lists without JavaScript. In this lesson, we will create a multi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kD5Dl3.html" rel="bookmark" class="title">《JavaScript高级程序设计》&mdash;&mdash;笔记&lpar;2&rpar;</a>
					<div>
						原型(prototype) 1.1访问原型的方法 function human () {} human.prototype.name = &quot;people&quot; human.protot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGzyoM.html" rel="bookmark" class="title">&lbrack;Mobx&rsqb; Use MobX actions to change and guard state</a>
					<div>
						This lesson explains how actions can be used to control and modify the state of your application. Th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzPEy4.html" rel="bookmark" class="title">MongoDB 学习笔记之 地理空间索引入门</a>
					<div>
						地理空间索引: 地理空间索引,可用于处理基于地理位置的查询. Point:用于指定所在的具体位置,我们以restaurants为例: db.restaurants.insert({name: &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZD29mM.html" rel="bookmark" class="title">Centos7 Apache 2&period;4&period;18编译安装</a>
					<div>
						安装环境:CentOS Linux release 7.0.1406 (Core) 0x01 到官网http://httpd.apache.org/download.cgi#apache24下载apa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWYKdB3.html" rel="bookmark" class="title">FTP服务学习笔记之基于MySQL&plus;PAM的vsftpd虚拟用户</a>
					<div>
						基于mysql+PAM的vsftpd虚拟用户配置 一.实验说明 操作系统:Redhat5.8_X64bit 实验平台:VMware Workstation 所需要的软件包:pam_mysql-0.7R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqEem4.html" rel="bookmark" class="title">python删除N天前文件</a>
					<div>
						#/usr/bin/env python # -*- coding:utf-8 -*- #Author='Jun' import os import sys import time def remov ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZyvEM.html" rel="bookmark" class="title">文件倒读</a>
					<div>
						In [1]: cat /tmp/1.txt a   b c d In [2]: ll /tmp/1.txt  应该是有8个字符,每个字符后边都有一个换行符号\n,加上换行符共8个字节. -rw-r- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAPPk4.html" rel="bookmark" class="title">十五、条件格式</a>
					<div>
						利用条件格式的设置,使单元格符合某个条件时,会显示指定的格式. 开始--条件格式 一.使用简单的条件格式 二.定义多重条件的条件格式 三.使用公式定义条件格式					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZlQy3.html" rel="bookmark" class="title">Appium学习实践（四）结构优化</a>
					<div>
						随着我们测试脚本中的用例越来越多,我们不可能将所有的用例都放在同一个脚本中,所以我们需要优化我们的结构.将脚本放在一个文件夹中,再通过别的脚本来执行脚本.这样,我们也可以有选择性的执行我们的脚本 先来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azwwg3.html" rel="bookmark" class="title">Leetcode&colon; Nth Digit</a>
					<div>
						Find the nth digit of the infinite integer sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, ... Note: n i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wEqq0.html" rel="bookmark" class="title">高质量代码-并和链表</a>
					<div>
						描述:输入两个单调递增的链表,输出两个链表合成后的链表,当然我们需要合成后的链表满足单调不减规则. 解决: 1 public class Solution { 2 //实现了原址并和,复杂度O(n)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvbd1M.html" rel="bookmark" class="title">scala 第一课</a>
					<div>
						val msg=&quot;Hello,World&quot; Scala 可以根据赋值的内容推算出变量的类型.这在Scala语言中成为&quot;type inference&quot;. Scal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oy8QoM.html" rel="bookmark" class="title">&period;NET静态变量与静态方法并发的问题</a>
					<div>
						我们知道,静态变量与静态方法都是在程序编译的时候就定义好了的,并且不会存在多个副本.所以对于静态变量来说,一旦修改了就会影响全局. 因此,静态变量是存在并发性问题的,所以当我们在操作静态变量的时候需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpaPo4.html" rel="bookmark" class="title">Windows客户端C&sol;C&plus;&plus;编程规范&OpenCurlyDoubleQuote;建议&rdquo;&mdash;&mdash;变量和常量</a>
					<div>
						8 变量和常量 8.1 尽量不要使用全局变量 等级:[要求] 说明:全局变量的滥用和goto的滥用一样,都是一种灾难.它将使得逻辑变得难以调试和控制. 8.2 不涉及外部使用的全局变量需要使用stat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l178X3.html" rel="bookmark" class="title">【Query处理学习笔记】搜索引擎查询推荐技术综述&lowbar;中文信息学报2010&lowbar;王斌</a>
					<div>
						主要内容:对通用搜索引擎的查询推荐技术的方法.评价进行了总结 具体内容: &quot;查询推荐&quot;的不同英文叫法:Query Suggestion.Term Suggestion.Query  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47X5v6M.html" rel="bookmark" class="title">PYTHON设计模式，创建型之工厂方法模式</a>
					<div>
						我感觉和上一个差不多,可能不要动最要的地方吧... #!/usr/bin/evn python #coding:utf8 class Pizza(object): def prepare(self,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pDRNP4.html" rel="bookmark" class="title">类的有参</a>
					<div>
						语法: &lt;访问修饰符&gt; 返回值类型 &lt;方法名&gt;(&lt;参数列表&gt;){ //方法的主体 } &lt;参数列表&gt;:是传送给方法的参数列表.列表中各参数间以逗号分隔.参 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
